import java.io.*;
import java.lang.*;
import java.lang.Character;
/*=====================================================================
*Luokka asiakkaan henkiltietojen tallennusta varten. Luokan kenttiin
*voidaan tallettaa virheellisi tietoja, mutta syntymajan ja 
*shkpostiosoitteen virheellisyys voidaan tarkistaa omilla metodeil
*llaan 

*Kirjoittanut: Ahti Syreeni
*Pvm: 1.2.2000
=====================================================================*/

public class Asiakas implements Serializable{
	private final int alinSallittuSyntymvuosi=1890;
  private String etunimi;
	private String sukunimi;
  private String syntymaika;
  private String katuosoite;
	private String postinumero;
  private String kaupunki;
  private String puhelinnumero;
  private String shkpostiosoite;
  private String maa;
	private Tuote tuoteviite;
  //------------------------------------------------------------------
	
  public Asiakas(String sukunimi){
		this.sukunimi=sukunimi;
  }
	public Asiakas(){
		this.sukunimi=null;
		this.etunimi=null;
	}
  //---------------------triviaalit aksessorit------------------------
  public String annaEtunimi(){
  	return this.etunimi;	
  }
  public String annaSukunimi(){
  	return this.sukunimi;	
  }
  public String annaSyntymaika(){
  	return this.syntymaika;	
  }
  public String annaKatuosoite(){
 	  return this.katuosoite;	
  }
  public String annaKaupunki(){
  	return this.kaupunki;	
  }
  public String annaMaa(){
 	  return this.maa;	
  }
  public String annaPuhelinnumero(){
	 	return this.puhelinnumero;	
  }
  public String annaPostinumero(){
	 	return this.postinumero;	
  }
  public String annaShkpostiosoite(){
  	return this.shkpostiosoite;	
  }
  public Tuote annaTuote(){
		/**metodi palauttaa viitteen Tuote-olioon, eli asiakkaan
			 omistamaan tuotteeseen*/
	 	return this.tuoteviite;            
  }
  public void asetaEtunimi(String etunimi){
	 	this.etunimi=this.muokkaaNimi(etunimi);	
  }
  public void asetaSukunimi(String sukunimi){
		/**metodi asettaa asiakkaan sukunimen: vain nimen ensimminen
			 kirjain on tmn jlkeen iso kirjain*/ 
	 	this.sukunimi=muokkaaNimi(sukunimi);	
  }
  public void asetaSyntymaika(String syntymaika){
		this.syntymaika=syntymaika.trim();
  }
  public void asetaKatuosoite(String osoite){
  	this.katuosoite=osoite.trim();	
  }
  public void asetaKaupunki(String kaupunki){
		/**metodi asettaa asiakkaan kotikaupungin, kaupungin nimen
			 ensimminen kirjain tulee isoksi, muut pieneksi*/
	 	this.kaupunki=this.muokkaaNimi(kaupunki);	
  }
  public void asetaPuhelinnumero(String numero){
		this.puhelinnumero=numero.trim();	
  }
  public void asetaPostinumero(String numero){
		this.postinumero=numero.trim();	
  }
  public void asetaShkpostiosoite(String osoite){
		this.shkpostiosoite=osoite.trim();	             
  }
  public void asetaMaa(String maa){
		this.maa=maa.trim();
  }
  public void asetaTuote(Tuote tuoteviite){
		/**metodilla asetetaan viite Tuote-olioon eli asiakkaan 
			 omistamaan tuotteeseen. Tuotteita voi tll asiakkaalla
			 olla vain yksi*/
		this.tuoteviite=tuoteviite;
	}
  //--------------------------Virheentarkistukset---------------------
	public boolean syntymajassaVirhe(){
		/**metodi tarkistaa, onko kentt syntymaika oikein:
			 piv vlill 1-31, kuu 1-12 ja vuosi yli luokan vakion
			 "alinSallittuSyntymvuosi". Pivysjonossa kaksi ensimmist
			 merkki ovat piv, kaksi seuraavaa kuukausi ja nelj viimeist
			 vuosi: esim 1.2.1980=01021980. Metodi kytt luokan Virheentar-
			 kistus palveluja*/
		if(Virheentarkistus.pivys(this.syntymaika,
																this.alinSallittuSyntymvuosi))
			return false;
		else
			return true; 
  }
	public boolean shkpostiosoitteessaVirhe(){
		/**metodi tarkistaa, onko shkpostiosoitekentss virhe.
			 virheen aiheuttaa @-merkin puutuminen. Metodi kytt
			 luokan Virheentarkistus palvelua*/
		if(Virheentarkistus.shkpostiosoite(this.shkpostiosoite))
			return false;
		else
			return true;
	}

  //--------------------------Apumetodit------------------------------
	private String muokkaaNimi(String nimi){
		/**pieni apumetodi luokan omaan kyttn, joka muuttaa annetun 
			 merkkijonon ensimmisen kirjaimen isoksi,muut pieniksi ja 
			 palauttaa muutetun merkkijonon*/

		char[] apu;
		String palautettava="";
		try{
    	if(nimi==null || nimi=="")
				return nimi;
			nimi=(nimi.trim().toLowerCase()); //ymprilt tyhjt pois ja 
			apu=nimi.toCharArray();						//kaikki kirjaimet pieniksi
			apu[0]=Character.toUpperCase(apu[0]); //eka kirjain isoksi
			for(int i=0; i<apu.length;i++)
				palautettava+=apu[i];		//taulukosta takaisin stringiksi
			return palautettava;
		}catch(Exception e){
			return nimi;							//jos sattuu yllttv virhe, 
		}														//palautetataan syte takaisin
	}
	public String toString(){
		return (this.sukunimi+", "+this.etunimi+"syntynyt: "
						+this.syntymaika+"Osoite: "+this.katuosoite+", "
						+this.kaupunki+", "+this.maa+", puh."+this.puhelinnumero+
						"email: "+this.shkpostiosoite);
	}
}
