import java.util.Vector;
import java.io.*;

/**====================================================================
* Luokka asiakaskortiston luomiseksi. Luokka tarjoaa palvelut yksin- 
*	kertaisen kortiston luomiseksi ja yllpitmiseksi sek mahdollisuudet
*	luoda luokalle aliluokka,joka pystyy huolehtimaan mys mahdollisista
*	asiakkaiden omistamista tuotteista. 
*
* Kirjoittanut: Ahti Syreeni
* Pvm: 9.2.2000
=====================================================================*/

public class Asiakaskortisto implements Serializable{
  protected int ksiteltvKortti=0; //ksiteltv elementti vektorissa
  protected Asiakas ksiteltvAsiakas; //suora viite asiakkaaseen
  protected String kortistonNimi; //ei pakollinen
	protected Vector asiakkaat; //itse kortisto
	protected boolean ksiteltvAsiakasTallessa; 
				//tosi, kun ksiteltv asiakas kopioitu vektoriin "asiakkaat"  
	protected Object tuoteIlmanOmistajaa; 
				//viite tuhotun asiakkaan omistamaan tuotteeseen mahdollista
				//mahdollista aliluokkaa varten
	private boolean	tietojaEimuutettu; 	//tosi, kun ksiteltvn 
																			//asiakkaan kentti ei muutettu

  //----------------------konstruktorit-------------------------------
  public Asiakaskortisto(){
		this.ksiteltvAsiakas=new Asiakas(); //ei saa koskaan olla null!
		this.asiakkaat=new Vector();
		this.ksiteltvAsiakasTallessa=false; //asiakas ei viel 
																					 //kortistossa
		this.tietojaEimuutettu=true;
  }
  public Asiakaskortisto(String nimi){
		this.ksiteltvAsiakas=new Asiakas();
		this.kortistonNimi=nimi;
		this.asiakkaat=new Vector();
		this.ksiteltvAsiakasTallessa=false;
		this.tietojaEimuutettu=true; 
  }
  //----------------------triviaalit aksessorit-----------------------
  public String annaEtunimi(){
		return this.ksiteltvAsiakas.annaEtunimi();
  }
	public String annaSukunimi(){
		return this.ksiteltvAsiakas.annaSukunimi();
	}
  public String annaSyntymaika(){
		return this.ksiteltvAsiakas.annaSyntymaika();
  }
  public String annaKatuosoite(){
		return this.ksiteltvAsiakas.annaKatuosoite();
  }
  public String annaPostinumero(){
		return this.ksiteltvAsiakas.annaPostinumero();
  }
	public String annaKaupunki(){
		return this.ksiteltvAsiakas.annaKaupunki();
  }
  public String annaMaa(){
		return this.ksiteltvAsiakas.annaMaa();
  }
  public String annaPuhelinnumero(){
		return this.ksiteltvAsiakas.annaPuhelinnumero();
  }
  public String annaShkpostiosoite(){
		return this.ksiteltvAsiakas.annaShkpostiosoite();
  }
  public String annaKortistonNimi(){
		return this.kortistonNimi;
  }
  public void asetaSukunimi(String sukunimi){
		this.ksiteltvAsiakas.asetaSukunimi(sukunimi);
		if(sukunimi!=null)
			this.tietojaEimuutettu=false; //asiakas pit tallentaa 
  }
  public void asetaEtunimi(String etunimi){
		this.ksiteltvAsiakas.asetaEtunimi(etunimi);
		if(etunimi!=null)
			this.tietojaEimuutettu=false; 
  }
  public void asetaKatuosoite(String osoite){
		this.ksiteltvAsiakas.asetaKatuosoite(osoite);
		if(osoite!=null)
			this.tietojaEimuutettu=false; 
  }
  public void asetaKaupunki(String kaupunki){
		this.ksiteltvAsiakas.asetaKaupunki(kaupunki);
		if(kaupunki!=null)
			this.tietojaEimuutettu=false; 
  }
  public void asetaPuhelinnumero(String numero){
		this.ksiteltvAsiakas.asetaPuhelinnumero(numero);
		if(numero!=null)
			this.tietojaEimuutettu=false; 
  }
  public void asetaPostinumero(String numero){
		this.ksiteltvAsiakas.asetaPostinumero(numero);
		if(numero!=null)
			this.tietojaEimuutettu=false; 
  }
  public void asetaShkpostiosoite(String osoite){
		this.ksiteltvAsiakas.asetaShkpostiosoite(osoite);
		if(osoite!=null)
			this.tietojaEimuutettu=false; 
  }
  public void asetaMaa(String maa){
		this.ksiteltvAsiakas.asetaMaa(maa);
		if(maa!=null)
			this.tietojaEimuutettu=false; 
  }
 	public void asetaSyntymaika(String aika){
		this.ksiteltvAsiakas.asetaSyntymaika(aika);
		if(aika!=null)
			this.tietojaEimuutettu=false; 
  }
  //----------------------virheentarkistus----------------------------
	public boolean syntymajassaVirhe(){
		/**ilmoittaa, onko ksiteltvn asiakkaan syntymaika oikein ja 
			oikeassa muodossa*/
		return this.ksiteltvAsiakas.syntymajassaVirhe();
	}
	public boolean shkpostiosoitteessaVirhe(){
		/**ilmoittaa, voiko ksiteltvn asiakkaan shkpostiosoite olla
			 shkpostiosoite, eli sisltk se merkin '@'*/
		return this.ksiteltvAsiakas.shkpostiosoitteessaVirhe();
	}
  //------------uuden asiakkaan lisminen kortistoon-----------------
	public void vieKortistoon(){
		/**lis ksiteltvn asiakkaan kortistoon kytten luokan toista
			 samannimist, parametrillista metodia*/
		this.vieKortistoon(true);
	}
	public boolean vieKortistoon(boolean muutKenttEnnallaan){
		/**lis ksiteltvn asiakkaan kortistoon, mikli ksiteltvn
			 asiakasolion kaikki kentt eivt ole tyhjt. Jos sukunimi puut-
			 tuu, sukunimeksi tulee '-', jos saman nimisi etunimen pern
			 listn numero n, so. monesko samanniminen (muodossa [n]).
			 Asiakkaat listn aina nousevaan aakkosjrjestykseen.
			 Parametri on luokan mahdollisia aliluokkia varten, jotta ne
			 voisivat ilmaista, mikli niiss on tapahtunut muutoksia*/ 
		String listtvnKokoNimi;
		if(this.tietojaEimuutettu && muutKenttEnnallaan)
  		return false; 		//lomake kokonaan tyhj tai jo tallennettu
		if(this.asiakkaat.indexOf(this.ksiteltvAsiakas)>-1)
			this.asiakkaat.remove(this.ksiteltvAsiakas);
			//poistetaan aikaisempi kopio kortistosta
		int nimilaskuri=0;	
		if(this.annaSukunimi()==null || this.annaSukunimi().equals(""))
			this.asetaSukunimi("-"); //sukunimi ei voi olla null
		if(this.haeAsiakasvektoriIndeksi(this.annaSukunimi()
																			+this.annaEtunimi(),true)>-1)
			nimilaskuri++;  //tutkitaan,onko samannimisi jo kortistossa

		while(this.haeAsiakasvektoriIndeksi((this.annaSukunimi()
																				+this.annaEtunimi()+
																				"["+nimilaskuri+"]"),true)>-1)
			nimilaskuri++;
		if(nimilaskuri>0)
			this.asetaEtunimi(this.annaEtunimi()+"["+nimilaskuri+"]");
			//jos samannimisi asiakkaita, nimen pern tunnistusnumero [n]

		if(this.asiakkaat.size()>0){
			listtvnKokoNimi=this.annaSukunimi()+	//tehdn merkkijono 
												 this.annaEtunimi();	//hakua varten
			Asiakas verrattava;
			String verrattavaNimi;
			boolean listtyVektoriin=false;
			int i=0;
			while(!listtyVektoriin && i<this.asiakkaat.size()){
				verrattava=(Asiakas)this.asiakkaat.elementAt(i);
				verrattavaNimi=verrattava.annaSukunimi()+		 	
											 verrattava.annaEtunimi();	
				if(listtvnKokoNimi.compareTo(verrattavaNimi)<0){
   				this.asiakkaat.insertElementAt(this.ksiteltvAsiakas,i);
					this.ksiteltvKortti=i;		//haetaan aakkosellisesti oikea
					listtyVektoriin=true;			//kortiston kohta ja listn
				}															//asiakas
				else
					i++;
			}
			if(i>=this.asiakkaat.size()){
				this.asiakkaat.addElement(this.ksiteltvAsiakas);
				this.ksiteltvKortti=this.asiakkaat.size()-1;
			} //olikin vektorin viimeinen, oli kytettv addElement()-metodia
		}
		else{
			this.asiakkaat.addElement(this.ksiteltvAsiakas);
			this.ksiteltvKortti=0;
			//oli ensimminen asiakas, joten listtiin tyhjn vektoriin		
		}
		this.ksiteltvAsiakasTallessa=true;
		this.tietojaEimuutettu=true;
		return true;
  }
	public void uusiAsiakas(){
		/**metodi ottaa ksiteltvksi asiakkaaksi uuden tyhjn asiakasolion
			 Jos,nykyinen ksiteltvasiakas ei kortistossa, se viedn ensin 
			 sinne vieRekisteriin()-metodilla*/
		if(!this.ksiteltvAsiakasTallessa)
			this.vieKortistoon();
		this.ksiteltvAsiakas= new Asiakas();
		this.ksiteltvAsiakasTallessa=false;
		this.tietojaEimuutettu=true;
	}
  public boolean poistaAsiakas(String nimi){
		/**metodi poistaa annetun nimisen asiakkaan kortistosta. Nimess 
			 oltava ensin suku-ja sitten etunimi.Vlill saa olla tyhj tai 
			 pilkku.*/
		int vektoriIndeksi;
		Asiakas asiakas;

		vektoriIndeksi=this.haeAsiakasvektoriIndeksi(nimi,true);
		if(vektoriIndeksi<0) //kytettiin luokan apumetodia hakemaan oikea
			return false;			 //kohta asiakaskortista,eli vektori-indeksi
		asiakas=(Asiakas)this.asiakkaat.elementAt(vektoriIndeksi);
		this.tuoteIlmanOmistajaa=asiakas.annaTuote(); //vlitetn tieto
		this.asiakkaat.remove(asiakas);	//mahdolliselle aliluokalle, 
		if(this.asiakkaat.size()==0){		//mik tuote olisi poistettava
			this.ksiteltvAsiakas=new Asiakas();
			this.ksiteltvKortti=-1; //poistettiin viimeinen asiakas,
		}														 //asetetaan luokka alkutilaan
		else if(vektoriIndeksi>this.asiakkaat.size()-1){
			this.ksiteltvAsiakas=(Asiakas)this.asiakkaat.elementAt(
																						this.asiakkaat.size()-1);
			this.ksiteltvKortti=this.asiakkaat.size()-1;	 	
		}							//asetetaan ksiteltv asiakkaaksi kortiston 
									//viimeinen
		else{
			this.ksiteltvAsiakas=(Asiakas)this.asiakkaat.elementAt(
																											vektoriIndeksi);
			this.ksiteltvKortti=vektoriIndeksi; 
		}		//ksiteltv on nyt se, joka tuli poistetun paikalle
		this.tietojaEimuutettu=true;
		return true;
  }
  public void selaa(int montako, boolean eteenpin){
		/*metodilla voidaan selata kortistoa tietty mr joko eteen 
			tai taakse. Jos menee yli kortiston, ksiteltv asiakas 
			on kortiston viimeinen, jos liian pieni, ksiteltv
			asiakas on kortiston ensimminen*/
		if(this.asiakkaat.size()<2) 
			return;	//alle kahden kortin kortistoa ei voi selata
		if(!ksiteltvAsiakasTallessa){
			int nykyindeksi=this.ksiteltvKortti;
			this.vieKortistoon();//talletetaan nykyinen asiakas
			this.ksiteltvKortti=nykyindeksi;
		}
		if(eteenpin)
			this.ksiteltvKortti+=montako; //selataan
		else
			this.ksiteltvKortti-=montako;
		if(this.ksiteltvKortti>this.asiakkaat.size()-1)
			this.ksiteltvKortti=this.asiakkaat.size()-1;
	  if(this.ksiteltvKortti<0)
				this.ksiteltvKortti=0;
		this.ksiteltvAsiakas=(Asiakas)asiakkaat.elementAt
														(this.ksiteltvKortti);
		this.tietojaEimuutettu=true; //tmn asiakkaan tiedot tallessa
		this.ksiteltvAsiakasTallessa=true;

  }
  public int asiakasmr(){
		/**antaa kortiston koon*/
		return asiakkaat.size();
  }

	//----------------------apumetodit----------------------------------------
	protected int haeAsiakasvektoriIndeksi(String haettava, boolean 
																															 tsmllinen){
	  /**apumetodi, joka hakee oikean vektorin indeksin annetun nimiselle.
			Jos asiakas ei kortistossa palautetaan -1. Nimess ensin suku-
			ja sitten etunimi. Jos parametri tsmllinen=true, pit nimen tsmt 
			merkilleen oikein, muuten riitt, ett annettu merkkijono lytyy
			kortistossa varrattavan nimen alusta*/
		int alku=0;
		int loppu=this.asiakkaat.size()-1;
		int keski=0;
		String hakunimi=this.muutaSyteHakunimijonoksi(haettava);
							//muutettiin annettu nimi apumetodilla sopivaksi 
		if(!tsmllinen){
			while (alku<=loppu){				//lytymiseen riitt, ett verrattav 
																	//nimen alku sislt haettavan nimen 
				keski=(alku+loppu)/2;			//kytetn binrihakua	

				Asiakas apu= (Asiakas)this.asiakkaat.elementAt(keski);
				String tarkasteltava=apu.annaSukunimi()+apu.annaEtunimi();
				tarkasteltava=tarkasteltava.toLowerCase();
				if(tarkasteltava.indexOf(hakunimi)==0)
					return keski;
				else{		
					if(hakunimi.compareTo(tarkasteltava)<0)
						loppu=keski-1;
					else
						alku=keski+1;
				}
			}
		}
		else{
			while (alku<=loppu){				//haettavan merkkijonon on oltava 
				keski=(alku+loppu)/2;			//vertailtavan asiakkaan nimi
																	//normaali binrihaku
				Asiakas apu= (Asiakas)this.asiakkaat.elementAt(keski);
				String tarkasteltava=apu.annaSukunimi()+apu.annaEtunimi();
				tarkasteltava=tarkasteltava.toLowerCase();
				if(tarkasteltava.equals(hakunimi))
					return keski;
				else{		
					if(hakunimi.compareTo(tarkasteltava)<0)
						loppu=keski-1;
					else
						alku=keski+1;
				}
			}
		}
		return -1;
 	}
	protected String muutaSyteHakunimijonoksi(String syte){
		/**apumetodi, joka muuttaa annetun sytteen sellaiseen muotoon,
			 ett sill voidaan hakea asiakaskortistosta: ylimriset
			 tyhjt ja pilkut poistetaan, kaikki kirjaimet pieniksi*/ 
		char[] apu;
		String nimi;

		nimi=syte.replace(',',' '); //pilkku voi olla mys viimeisen
		nimi=nimi.trim();

		apu=nimi.toCharArray();
		boolean ok=false;
		while(!ok){
			for(int i=0; i<apu.length; i++){ //poistetaan tyhjt vleist
				if(apu[i]==',' || apu[i]==' '){	
				  for(int j=i; j<apu.length-1;j++){
				    apu[j]=apu[j+1];
				    apu[j+1]=' ';
					}
				}
			}
		  nimi=new String(apu);
		  nimi=nimi.trim();
			if(nimi.indexOf(' ')<0 && nimi.indexOf(',')<0)
				ok=true; //toistetaan, kunnes kaikki tyhjt poissa
		}	
		return nimi.toLowerCase();	
	}

	public String toString(){
		/**antaa merkkiesityksen kortiston tilasta*/
   	return ("Kortti:"+this.ksiteltvKortti+",Asiakas:"
						+this.annaSukunimi()+"Kortiston nimi"+this.kortistonNimi+
						", kortteja:"+this.asiakkaat.size());	
	}

	//----------------------testipohjelma------------------------------
	public static void main(String[] args){
		Asiakaskortisto koe=new Asiakaskortisto();
		//testataan nimien asettamista
	 	for(int i=0;i<7;i++){
			System.out.println(i+" sukunimi:");
			koe.asetaSukunimi(Lue.rivi());
			System.out.println(i+" etunimi:");
			koe.asetaEtunimi(Lue.rivi());
			koe.uusiAsiakas();
		}
	} 
}
