import java.util.Vector;
import java.io.*;
/**====================================================================
*	Luokka asiakasrekisterin luomista varten. Rekisteriss voi asiakkail-
*	la olla tuotteita ja rekisteri tarjoaa asiakkaiden ja tuotteiden 
*	lisys-,poisto- sek hakupalvelut.
*
* Kirjoittanut: Ahti Syreeni
* Pvm: 11.2.2000
=====================================================================*/

public class Asiakasrekisteri extends Asiakaskortisto 
															 implements Serializable{
  private Vector tuotteet;     
  private Vector kytetytSarjanumerot;
	private boolean tietojaEimuutettu;
  private Tuote ksiteltvTuote;
	private int nimettmtTuotteet;

  //--------------------konstruktori----------------------------------

	public Asiakasrekisteri(){
		super();
	 	this.ksiteltvTuote= new Tuote();
	 	this.kytetytSarjanumerot= new Vector(); 
	 	this.tuotteet= new Vector();
		this.tietojaEimuutettu=true;
		this.ksiteltvTuote.asetaOmistaja(super.ksiteltvAsiakas);
		super.ksiteltvAsiakas.asetaTuote(this.ksiteltvTuote);
	  this.nimettmtTuotteet=0;
	}

	//-------------------triviaalit aksessorit tuotteille---------------

  public String annaRekisteritymispiv(){
		return this.ksiteltvTuote.annaRekisteritymispiv();
  }
  public String annaSarjanumero(){
		return this.ksiteltvTuote.annaSarjanumero();
  }
  public String annaTuote(){
		return this.ksiteltvTuote.annaTuote();
  }
  public void asetaTuote(String tuote){
		this.ksiteltvTuote.asetaTuote(tuote);
		if(tuote!=null)
			this.tietojaEimuutettu=false;
  }
  public void asetaRekisteritymispiv(String piv){
	  this.ksiteltvTuote.asetaRekisteritymispiv(piv);
		if(piv!=null)
			this.tietojaEimuutettu=false;
  }
  public boolean asetaSarjanumero(String sarjanumero){
		/**asettaa tuotteen sarjanumeron. Jos sarja numero on jo kytetty
			 annettua sarjanumeroa ei tallenneta,vaan sarjanumerokentt j
			 tyhjksi. Sarjanumerot eivt palaudu kyttn tuotteen poiston
			 yhteydess*/
		if(sarjanumero==" " || sarjanumero==null) 
			return false;
  	int keski,alku=0;
		int loppu=this.kytetytSarjanumerot.size()-1;
		while (alku<=loppu){		//tarkistetaan, onko numero jo kytetty 
			keski=(alku+loppu)/2;			
			String tarkasteltava=(String)this.kytetytSarjanumerot.elementAt(
																																keski);
			if(tarkasteltava.equalsIgnoreCase(sarjanumero)){
				return false; //kytetn binrihakua
			}
			else{		
				if(sarjanumero.compareTo(tarkasteltava)<0)
					loppu=keski-1;
				else
					alku=keski+1;
			}
		}
		//sarjanumero ei ole viel kytss,voidaan kytt 
		//ja merkit listaan
		this.ksiteltvTuote.asetaSarjanumero(sarjanumero);
		boolean listtyVektoriin=false;
		String verrattava;
		int i=0;

		while(!listtyVektoriin && i<this.kytetytSarjanumerot.size()){
			verrattava=(String)this.kytetytSarjanumerot.elementAt(i);
			if(sarjanumero.compareTo(verrattava)<0){	
   			this.kytetytSarjanumerot.insertElementAt(sarjanumero,i);
				listtyVektoriin=true;	//haetaan oikea kohta, kytetyt sarja-
			}													//numerot pidetn jrjestylsess bi-
			else{											//nrihakua varten
				i++;
			}
		}
		if(i >= this.kytetytSarjanumerot.size()) 
			this.kytetytSarjanumerot.addElement(sarjanumero);
															//olikin jrjestyksen viimeinen
		this.tietojaEimuutettu=false;
		return true;
  }

	//-----------------------Hakutoiminnot-------------------------------

  public String[] haeNimell(String syte){
		/**metodi hakee ne asiakkaat, joiden nimen alku sislt annetun 
			 merkkijonon. Jos ei lytyneit,palautetaan null*/
		Vector tulos=new Vector(); //hakutulos
		Asiakas tarkasteltava;
		String haettavanNimi,tarkasteltavanNimi;
		int asiakasvektoriIndeksi;
		this.vieRekisteriin(); //tallennetaan tmnhetkinen asiakas
		asiakasvektoriIndeksi=super.haeAsiakasvektoriIndeksi(syte,false);
							//haetaan oikea kohta Asiakaskortiston apumetodilla						
		if(asiakasvektoriIndeksi<0)
			return null;
		else{
			haettavanNimi=super.muutaSyteHakunimijonoksi(syte);
			int i=0;
			boolean ekaLydetty=false;
			while(!ekaLydetty){ 							//kelataan taaksepin, kunnes 
				if((asiakasvektoriIndeksi-i)<0) //saavutettu ensimminen 
					ekaLydetty=true;							//haettu asiakas
			  else{												//(jos binhaku ei sattunut ekaan)
					tarkasteltava=(Asiakas)super.asiakkaat.elementAt(
																							asiakasvektoriIndeksi-i);
					tarkasteltavanNimi=(tarkasteltava.annaSukunimi()+
											tarkasteltava.annaEtunimi()).toLowerCase();
					if(tarkasteltavanNimi.indexOf(haettavanNimi)!=0)
						ekaLydetty=true;
  				else
						i++;
				}
			}					
 			int aloituskohta=asiakasvektoriIndeksi-i+1;
			i=0;
			boolean viimeinenLydetty=false; //kertn kaikki kelvolliset 
  		while(!viimeinenLydetty){			 //asiakkaat tulosvektoriin
				if((aloituskohta+i)>super.asiakkaat.size()-1){
					if(tulos.size()<=0){
  				  tarkasteltava=(Asiakas)super.asiakkaat.elementAt(
																												aloituskohta);
            tulos.addElement(tarkasteltava.annaSukunimi()+", "
						+tarkasteltava.annaEtunimi());
						//lydettyj vain yksi
					}
					viimeinenLydetty=true;
				}
			 	else{
 				  tarkasteltava=(Asiakas)super.asiakkaat.elementAt(
																											aloituskohta+i);
				  tarkasteltavanNimi=(tarkasteltava.annaSukunimi()
												+tarkasteltava.annaEtunimi()).toLowerCase();
					if(tarkasteltavanNimi.indexOf(haettavanNimi)==0){
            tulos.addElement(tarkasteltava.annaSukunimi()+", "
						+tarkasteltava.annaEtunimi());
						i++;
				  }
					else
						viimeinenLydetty=true;
				}
			}					
			//asetetaan ksiteltvksi asiakkaaksi ensimminen lydetty
			this.asetaKsiteltvAsiakas(aloituskohta); 
			//muutetaan tulosvektori String-taulukoksi apumetodilla ja 
			//palautetaan
			return this.muutaStringTaulukoksi(tulos); 
    }
  }
  public String[] haeKaikki(boolean nousevaJrjestys){
		/**haetaan kaikkien kortistossa olevien asiakkaiden nimet muodossa:
			 Sukunimi,Etunimi. Parametri mr jrjestyksen*/
		Asiakas apu;
		String[] hakutulos= new String[super.asiakkaat.size()];
		this.vieRekisteriin(); //tallennetaan tmnhetkinen asiakas
		if(nousevaJrjestys){
			for(int i=0;i<super.asiakkaat.size();i++){
				apu=(Asiakas)super.asiakkaat.elementAt(i); //kertn nimet
				hakutulos[i]=apu.annaSukunimi()+", "+apu.annaEtunimi();
			}
			if(super.asiakkaat.size()>0){
				this.asetaKsiteltvAsiakas(0); //asetetaan ksiteltvksi
			}																	//asiakkaaksi ensimminen
		}
		else{
			for(int i=super.asiakkaat.size()-1;i>=0;i--){
				apu=(Asiakas)super.asiakkaat.elementAt(i);
				hakutulos[i]=apu.annaSukunimi()+", "+apu.annaEtunimi();
			}
			if(super.asiakkaat.size()>0){ //kertn nimet laskevasti
				this.asetaKsiteltvAsiakas((super.asiakkaat.size()-1));
			}
		}
		return hakutulos;
  }
  public String[] haeRekisteritymispivll(String pivys){
		/**haetaan rekisteritymispivll, annetun pivyksen oltava:
			 2 ensimmist numeroa piv (01-31), 2 seuraavaa kuu (01-12)
			 ja 4 seuraavaa vuosi*/
		Vector hakutulos=new Vector();
		Tuote tarkasteltava;
		Asiakas ensimminenLytynyt=null;
		this.vieRekisteriin(); //tallennetaan nykyinen asiakas
		boolean ekakerta=true;
		for(int i=0;i<this.tuotteet.size();i++){	//haetaan kaikki 
			tarkasteltava=(Tuote)this.tuotteet.elementAt(i); //haluttujen
			if(pivys.equalsIgnoreCase(							//tuotteiden omistajat
														tarkasteltava.annaRekisteritymispiv())){
				hakutulos.addElement(
												tarkasteltava.annaOmistaja().annaSukunimi()+", "
												+tarkasteltava.annaOmistaja().annaEtunimi());
				if(ekakerta){
					ensimminenLytynyt=tarkasteltava.annaOmistaja();
					ekakerta=false; //tallennettiin ensimminen lydetyn tuotteen
				}									//omistaja...
			}
		}
		if(ensimminenLytynyt!=null) //...ja asetetaan se ksiteltvksi
			this.asetaKsiteltvAsiakas(ensimminenLytynyt);
		//palautetaan tulosvektori muunnettuna merkkijonotaulukoksi
		return muutaStringTaulukoksi(hakutulos);
  }
  public String[] haeSyntymajalla(String syntymaika){
		/**hakee kaikkien annetulla syntymajalla syntyneiden nimet.	
			 Parametrin muoto on oltava seuraava:
			 2 ensimmist numeroa piv (01-31), 2 seuraavaa kuu (01-12)
			 ja 4 seuraavaa vuosi*/
  	Vector hakutulos=new Vector(); 
		Asiakas ensimminenLytynyt=null;
		this.vieRekisteriin(); //tallennetaan ksiteltv asiakas
		boolean ekakerta=true;
		for(int i=0;i<super.asiakkaat.size();i++){
			Asiakas tarkasteltava=(Asiakas)super.asiakkaat.elementAt(i);
			if(syntymaika.equals(tarkasteltava.annaSyntymaika())){
				hakutulos.addElement(tarkasteltava.annaSukunimi()+", "
														 +tarkasteltava.annaEtunimi());
				if(ekakerta){
					ensimminenLytynyt=tarkasteltava; 
					ekakerta=false;		
				}
			}
		}
		if(ensimminenLytynyt!=null)
			//asetetaan ensimminen lytynyt ksiteltvksi asiakkaaksi
			this.asetaKsiteltvAsiakas(ensimminenLytynyt);
			//palautetaan tulosvektori muunnettuna mjonotaulukoksi
		return muutaStringTaulukoksi(hakutulos);
  }
  public String[] haeTuotteella(String tuote){
		/**hakee kaikkien annetun tuotteen omistajien nimet*/
		Vector hakutulos=new Vector();
		Asiakas ensimminenLytynyt=null;
		this.vieRekisteriin(); //tallennetaan ksiteltv asiakas
		boolean ekakerta=true;
		for(int i=0;i<this.tuotteet.size();i++){
			Tuote tarkasteltava=(Tuote)this.tuotteet.elementAt(i);
			if(tuote.equals(tarkasteltava.annaTuote())){ 	//haetaan tuotteen 
				hakutulos.addElement(												//mukaan
										tarkasteltava.annaOmistaja().annaSukunimi()+", "+
										tarkasteltava.annaOmistaja().annaEtunimi());
				if(ekakerta){
					ensimminenLytynyt=tarkasteltava.annaOmistaja();
					ekakerta=false;		
				}
			}
		}
		if(ensimminenLytynyt!=null)
			//ksiteltv asiakas olkoon ensimminen lydetty
			this.asetaKsiteltvAsiakas(ensimminenLytynyt);
			//palautetaan tulosvektori taulukoksi muunnettuna
		return this.jrjest(this.muutaStringTaulukoksi(hakutulos));
  }
  public String haeSarjanumerolla(String sarjanumero){
		/**hakee tietyn asiakkaan sarjanumerolla, null, jos ei lydettyj*/
		Tuote tarkasteltava;
		this.vieRekisteriin();
		for(int i=0;i<this.tuotteet.size();i++){
			tarkasteltava=(Tuote)this.tuotteet.elementAt(i);
			if(tarkasteltava.annaSarjanumero().equalsIgnoreCase(sarjanumero)){
				this.asetaKsiteltvAsiakas(tarkasteltava.annaOmistaja());
				return tarkasteltava.annaOmistaja().annaSukunimi()+", " 
							 +tarkasteltava.annaOmistaja().annaEtunimi();
			}					
		}
		return null;
	}

	//------------------------tuotteiden hallinta------------------------

  public void lisTuote(){
		/**lis tuotteen tuotevektoriin,mikli kentiss on tietoa.*/
			
		if(this.tietojaEimuutettu)
			return; //tuotekentt tyhji, ei kannata tallentaa
		if(this.tuotteet.indexOf(this.ksiteltvTuote)>-1)
			this.tuotteet.remove(this.ksiteltvTuote); 
		if(this.tuotteet.size()>0){	//poistettiin edellinen kopio
			Tuote verrattava;
			String verrattavanNimi;
			boolean listtyVektoriin=false;
			int i=0;
			while((!listtyVektoriin) && (i<this.tuotteet.size())){
				verrattava=(Tuote)this.tuotteet.elementAt(i);
				verrattavanNimi=verrattava.annaTuote(); //listn aakkosjrj.
				if(this.annaTuote().compareTo(verrattavanNimi)<0){
   				this.tuotteet.insertElementAt(this.ksiteltvTuote,i);
					listtyVektoriin=true;
				}
				else
					i++;
			}
			if(i>=this.tuotteet.size()){
				this.tuotteet.addElement(this.ksiteltvTuote);
			} //oli viimeinen jrjestyksess, oli kytettv addElement()-metodia
		}
		else
			//onkin ihan ensimminen tuote, aloittaa listan
			this.tuotteet.addElement(this.ksiteltvTuote);
		this.tietojaEimuutettu=true;
  }
  public boolean poistaTuote(String poistettava, boolean omistajanPoisto){
		/**poistaa kaikki annetun nimiset tuotteet tuotevektorista. Jos 
			omistajanPoisto=true, mys tuotteen kaikki asiakkaat poistetaan*/
		Tuote tarkasteltava;
		Asiakas omistaja;
		this.vieRekisteriin();
		if(this.tuotteet.size()==0)
			return false;
		for(int i=0; i<this.tuotteet.size(); i++){
			tarkasteltava=(Tuote)this.tuotteet.elementAt(i);
			if(tarkasteltava.annaTuote().equalsIgnoreCase(poistettava)){
				int j=i; //kydn lpi kaikki poistettavat tuotteet
				while(tarkasteltava.annaTuote().equalsIgnoreCase(poistettava)&&
																								j<this.tuotteet.size()){
					omistaja=tarkasteltava.annaOmistaja();
					this.tuotteet.removeElementAt(j);
					if(omistajanPoisto)
						super.asiakkaat.removeElement(omistaja);
						if(j<this.tuotteet.size())	//poistetaan tuotteen omistaja
																				//kortiston asiakasvektorista				
              tarkasteltava=(Tuote)this.tuotteet.elementAt(j);
				}
			break; //ei tarvitse jatkaa, koska tuotteet aakkosjrjestyksess
			}
		}	
		this.asetaKsiteltvAsiakas(0);
		return true;
  }

	//----------------rekisterin hallinta--------------------------------

	public void vieRekisteriin(){
		/**vie asiakkaan ja tuotteen rekisteriin, jos kentiss on tietoa.*/
		if(this.tietojaEimuutettu){
			if(super.vieKortistoon(true))  //annetaan kortistolle tieto, 
				this.lisTuote();					 //ett mys tuotekentt ovat tyhjt
		}																 //jos kortisto on lisnnyt uuden 
																		 //asiakkaan,
		else{														 //voidaan list mys uusi tuote
			if(super.vieKortistoon(false))
				this.lisTuote();
		}	
		this.tietojaEimuutettu=true;
	}
	public void uusiAsiakas(){
		/**lataa uuden asiakas ja tuoteolion,joihin voidaan 
			 tallettaa tietoja.*/
		if(!super.ksiteltvAsiakasTallessa){
			this.vieRekisteriin(); //tallennetaan ksiteltv asiakas
		}
		super.uusiAsiakas();
		this.ksiteltvTuote=new Tuote();
		//pit asettaa tuoteviitteet asiakkaasta tuotteeseen ja pinvastoin
		this.ksiteltvTuote.asetaOmistaja(super.ksiteltvAsiakas);
		super.ksiteltvAsiakas.asetaTuote(this.ksiteltvTuote);
	}
	public boolean poistaAsiakas(String asiakas){
		/**poistaa annetun nimisen asiakkaan sek hnen tuotteensa*/
		Tuote asiakkaanTuote;
		this.vieRekisteriin();
		if(!super.poistaAsiakas(asiakas))
			return false; 
		asiakkaanTuote=(Tuote)super.tuoteIlmanOmistajaa;
		this.tuotteet.remove(asiakkaanTuote);
	   //poistettiin tuote, jolla ei en ollut omistajaa
		if(super.asiakkaat.size()==0){
			this.ksiteltvTuote=new Tuote(); //poistettiin viimeinen asiakas
			this.ksiteltvTuote.asetaOmistaja(super.ksiteltvAsiakas);
			super.ksiteltvAsiakas.asetaTuote(this.ksiteltvTuote);
		}
		this.asetaKsiteltvAsiakas(super.ksiteltvAsiakas, 
																							 super.ksiteltvKortti);
		return true;
	}	
	public void selaa(int montako, boolean eteenpin){
		/**selataan rekisteria tietty mr eteen tai taakse. Jos liikaa,
			 ksiteltvasiakas j viimeiseen asiakkaaseen ja jos liian vhn
			 ksiteltvksi asiakkaaksi tulee ensimminen asiakas*/
		this.vieRekisteriin();
		super.selaa(montako,eteenpin);
		this.ksiteltvTuote=super.ksiteltvAsiakas.annaTuote();
		this.tietojaEimuutettu=true;
	}
	public int tuotemr(){
		/**palauttaa rekisterin tuotemrn*/
		return this.tuotteet.size();
  }
  public int rekisteriKoko(){
		/**palauttaa rekisterin koon eli asiakasmrn*/ 
		return super.asiakkaat.size();
  }

	//-----------------Apumetodit----------------------------------------
	private void asetaKsiteltvAsiakas(Asiakas asiakas){
		/*kuten seuraava metodi,mutta asiakasviitteell*/
		if(asiakas==null)
			return;
		if(!super.ksiteltvAsiakasTallessa)
			this.vieRekisteriin(); //tallennetaan ksiteltv asiakas
		super.ksiteltvAsiakas=asiakas;
		this.ksiteltvTuote=super.ksiteltvAsiakas.annaTuote();
		super.ksiteltvKortti=super.asiakkaat.indexOf(asiakas);
		this.tietojaEimuutettu=true;
	}
	private void asetaKsiteltvAsiakas(Asiakas asiakas, 
																									int vektoriIndeksi){
		/*apumetodi, joka asettaa ksiteltvn asiakkaan piten huolta 
			siit, ett tuotteet pysyvt mukana*/
		if(asiakas!=null || vektoriIndeksi<0 || 
															vektoriIndeksi>super.asiakkaat.size()-1)
			return;
		if(!super.ksiteltvAsiakasTallessa)
			this.vieRekisteriin(); //ksiteltv asiakas ensin talteen
		super.ksiteltvAsiakas=asiakas;
		this.ksiteltvTuote=super.ksiteltvAsiakas.annaTuote();
		super.ksiteltvKortti=super.asiakkaat.indexOf(asiakas);
		this.tietojaEimuutettu=true;

	}
	private void asetaKsiteltvAsiakas(int vektoriIndeksi){
		if(vektoriIndeksi<0 || vektoriIndeksi>super.asiakkaat.size()-1)
			return;
		if(!super.ksiteltvAsiakasTallessa)
			this.vieRekisteriin();
		super.ksiteltvAsiakas=(Asiakas)super.asiakkaat.elementAt(
																											vektoriIndeksi);
		super.ksiteltvKortti=super.asiakkaat.indexOf(
																						super.ksiteltvAsiakas);
		this.ksiteltvTuote=super.ksiteltvAsiakas.annaTuote();
		this.tietojaEimuutettu=true;
	}

	public void tulostaTuotteet(){
		/**tulostaa kaikki rekisterin tuotteet ilman omistajatietoja, 
			 karsimatta samoja*/
		for(int i=0; i<this.tuotteet.size();i++)
			System.out.println((Tuote)this.tuotteet.elementAt(i));

	}
	private String[] muutaStringTaulukoksi(Vector muutettava){  
		/**apumetodi,joka muuttaa annetun vektorin merkkijonotaulukoksi*/
		String[] palautettava=new String[muutettava.size()];
		for(int i=0; i<muutettava.size();i++)
			palautettava[i]=(String)muutettava.elementAt(i);
		return palautettava;
	}	
	private String[] jrjest(String[] jrjestettv){
		/**apumetodi,joka jrjest merkkijonotaulukon nousevaan
			 jrjestykseen*/
		for (int i=1; i<jrjestettv.length; ++i) {
   		String apu = jrjestettv[i];
   		int j = i;
  		while (j > 0 && jrjestettv[j-1].compareTo(apu)>0) {
    		jrjestettv[j] = jrjestettv[j-1]; 
    		j--;
   		}
   		jrjestettv[j] = apu;
 		}
		return jrjestettv;
	}
}
