import java.io.*;
import java.util.Vector;
/*=====================================================================
* Apuluokka Html-tiedoston kirjoittamiseen
* 
* Kirjoittanut: Ahti Syreeni
* Pvm: 17.2.2000
=====================================================================*/
public class Html {
  private Vector komentopino; //alkutagit, joita ei viel ole ptetty
  private PrintWriter tiedosto;
  //---------------------konstruktori----------------------------------
	public Html(){
		this.komentopino=new Vector();
	}
  public boolean alustaTiedosto(String tiedostonimi,String otsikko, 
																											 boolean korvaa){
		/**metodilla asetetaan luokka kirjoitustilaan: asetetaan tiedosto,
			 johon kirjoitetaan ja kirjoitetaan otsikko sek alun mrittelyt
			 Jos korvaa=false, listn valmiiseen tiedostoon*/
		String validiTiedostonimi;
		if(tiedostonimi==null)
			return false;
		if(tiedostonimi.indexOf(".")>-1) //eliminoidaan pisteet t-nimest
			tiedostonimi=tiedostonimi.substring(0,tiedostonimi.indexOf("."));
		validiTiedostonimi=tiedostonimi.concat(".html");
	 	try{
			if(korvaa){
				this.tiedosto=new PrintWriter(new FileOutputStream(
																				validiTiedostonimi,false),true);
				this.tiedosto.println(
									"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2//EN\">");	 
				this.tiedosto.println("<html>"); 
				this.komentopino.addElement("</html>"); //tm on oltava viimeinen
				this.tiedosto.println("<head>");        //rivi tiedostossa
				if(otsikko!=null)
					this.tiedosto.println("  <title>"+otsikko+"</title>");
				this.tiedosto.println("</head>");
				this.tiedosto.println("<body>");
				this.komentopino.addElement("</body>");
			}
			else{
				this.tiedosto=new PrintWriter(new FileOutputStream(
																									tiedostonimi,true),true);
			}
		}catch(Exception e){
			return false;
		}
		return true;
  }
	//-------------------------------------------------------------------
  public boolean otsikko(String otsikko, int koko){
		/**kirjoittaa annetun otsikon annetulla koolla Html-tiedostoon*/
		if(otsikko==null || koko >9)
			return false;
		try{
			this.tiedosto.println("<h"+koko+">"+otsikko+"</h"+koko+">");
		}catch(Exception e){
			return false;
			//tiedostovirhe
		}
	return true;
  }
	//-------------------------------------------------------------------
 	public String shkposti(String henkil,String osoite, boolean vainOsoite){
		/**apumetodi, joka palauttaa merkkijonon, joka saa aikaan hyperlinkin
			 annettuun osoitteeseen ja nime sen henkiln nimell. Jos 
			 vainOsoite=true, linkin nimeksi tulee itse shkpostiosoite.*/
		String palaute;

		if(osoite==null)
			return henkil;
		if(vainOsoite)
			palaute=("<a href=\"mailto:"+osoite+"\">"+osoite+"</a>");
		else
			palaute=("<a href=\"mailto:"+osoite+"\">"+henkil+"</a>");
		return palaute;
	}
	//-------------------------------------------------------------------
  public boolean lista(boolean jrjestetty){
		/**aloittaa listan, parametrista riippuen joko jrjestetyn tai 
			 jrjestmttmn. Lista on itse suljettava kytten luokan
			 sulje()-metodia*/
		try{
			if(!jrjestetty){
				this.tiedosto.println("<ul>");
				this.komentopino.addElement("</ul>");	//lista on suljettava
			}
			else{
				this.tiedosto.println("<ol>");
				this.komentopino.addElement("</ol>");		
			}				
		}catch(Exception e){
			return false;
		}
	return true;
  }
	//-------------------------------------------------------------------
  public boolean listaAlkio(String sanat){
		/**lis annetun lista-alkion listaan*/
		if(sanat==null)
			return false;
		try{
			this.tiedosto.println("<li>"+sanat+"</li>");
		}catch(Exception e){
			return false;
		}
	return true;
  }
	//-------------------------------------------------------------------
  public boolean sulje(){
		/**sulkee edellisen sulkemista vaatineen alkutagin.Jos ei lopputageja
	     jljell, sulkee tiedoston*/
		String lopputagi;
		try{
			lopputagi=(String)this.komentopino.lastElement(); //otetaan pinosta
			this.tiedosto.println(lopputagi); 
			this.komentopino.removeElementAt(this.komentopino.size()-1);
			if(komentopino.size()==0)
				this.tiedosto.close();	
		}catch(Exception e){
			return false;
		}
		return true;
  }
	//-------------------------------------------------------------------
  public boolean pinoTyhj(){
		/**metodi ilmoittaa, onko kaikki sulkemista vaativat alkutagit
			 suljettu lopputageilla*/
		if(this.komentopino.size()==0)
			return true;
		else
			return false;
  }
}
