import java.io.*;
import java.awt.*;
import java.awt.event.*;
/*=====================================================================
* Asiakasrekisterin haku- ja poistopalvelut graafisesti tarjoava luokka. 
*	Tm luokka kytt luokkien: Asiakasrekisteri,Lomake,Tuotteet ja 
* Valikkkotoiminnot palveluja. Yhteydet on luokan luomisen jlkeen
* asetettava asetaYhteydet()-metodilla, jos luokkaa aijotaan kytt
* muuhunkin, kuin kyttliittymn hakuosion piirtmiseen ruudulle.
* 
* Kirjoittanut: Ahti Syreeni
* Pvm: 13.2.2000
=====================================================================*/
public class Tietokantapalvelut implements ActionListener{

	//-----------------------tarvittavat luokat--------------------------
	private Asiakasrekisteri  rekisteri;
	private Lomake 						lomake; 
	private Tuotteet 					tuotteet;
	private Valikkotoiminnot	valikkotoiminnot;
	//--------------------kyttliittymelementit------------------------
	private Checkbox 					nytKaikki, nytTuotteella, nytHaulla;
	private CheckboxGroup 		nappularyhm;													
	private Choice 						tuotelista, hakuperuste;	
	private List 							asiakaslista; 
	private Button 						nyt,poistaAsiakkaat,poistaKaikki;
	private TextField 				hakusana, hakupiv, hakukuu, hakuvuosi; 
	private Panel 						ylpaneeli,hakupaneeli, aikapaneeli,				 
				  									kokoJulkisivu, poistaPaneeli; 
  //---------------------konstruktori----------------------------------
	public Tietokantapalvelut(){
		this.kokoJulkisivu= new Panel(new GridLayout(4,1));
		//hakuvalintanappien luonti 
		this.nappularyhm=new CheckboxGroup();
		this.nytKaikki= new Checkbox("Kaikki",this.nappularyhm,true);
		this.nytTuotteella=new Checkbox("Tll tuotteella:",
																						this.nappularyhm,false);
		this.nytHaulla=new Checkbox("Haku",nappularyhm,false);

		//hakuehdot: kaikki ja haku tuotteella -komponenttien luonti
		this.ylpaneeli= new Panel(new GridLayout(2,3));
		this.nyt=new Button("Nyt!");	
		this.tuotelista=new Choice();
		this.ylpaneeli.add(this.nytKaikki);
		this.ylpaneeli.add(this.nytTuotteella);
		this.ylpaneeli.add(new Label(""));
		this.ylpaneeli.add(this.tuotelista);	
		this.kokoJulkisivu.add(this.ylpaneeli); //saatu paneeli julkisivuun
		//hakupaneelin luominen:		
		this.hakupaneeli= new Panel(new GridLayout(6,2));
		this.hakupaneeli.add(this.nytHaulla); //valintanappi
		this.hakupaneeli.add(new Label(""));		
		this.hakupaneeli.add(new Label("  hakuperuste:"));
		this.hakuperuste=new Choice();				 //lista, josta valitta-
																					 //vissa hakuperuste
		this.hakuperuste.add("nimi: suku, etu");
		this.hakuperuste.add("syntymaika");
		this.hakuperuste.add("sarjanumero");
		this.hakuperuste.add("rekisteritymispiv");
		this.hakupaneeli.add(this.hakuperuste);
		this.hakupaneeli.add(new Label("  hakusana:"));
		this.hakusana=new TextField(); 				
		this.hakupaneeli.add(this.hakusana);
  	this.hakupaneeli.add(new Label("  aika:"));
		this.hakupiv=new TextField("pvm",2); //aikakentt:piv,kuu,
		this.hakukuu=new TextField("kk",2);		 //vuosi
		this.hakuvuosi=new TextField("vv",4);
		this.aikapaneeli=new Panel(new GridLayout(1,3));
		this.aikapaneeli.add(this.hakupiv);  //tehdn oma aika-
		this.aikapaneeli.add(this.hakukuu);		 //paneeli
		this.aikapaneeli.add(this.hakuvuosi);
		this.hakupaneeli.add(this.aikapaneeli); 
		this.hakupaneeli.add(new Label(""));
		this.nyt=new Button("Nyt!");
		this.nyt.addActionListener(this);
		this.hakupaneeli.add(new Label(""));
		this.hakupaneeli.add(new Label("Asiakkaat:"));
		this.hakupaneeli.add(this.nyt);
		this.kokoJulkisivu.add(this.hakupaneeli);
		this.asiakaslista= new List(20,false);	
		this.asiakaslista.addActionListener(this);
		this.kokoJulkisivu.add(this.asiakaslista);
		//poistonappien asettelu
		this.poistaPaneeli=new Panel(new FlowLayout());
		this.poistaAsiakkaat= new Button("Poista valittu asiakas");
		this.poistaAsiakkaat.addActionListener(this);
		this.poistaPaneeli.add(this.poistaAsiakkaat);
		this.kokoJulkisivu.add(this.poistaPaneeli);	
		this.poistaKaikki= new Button("Poista kaikki");
		this.poistaKaikki.addActionListener(this);
		this.poistaPaneeli.add(this.poistaKaikki);
		this.kokoJulkisivu.add(this.poistaPaneeli);	
	}

	//------------------------yleiset------------------------------------
  public void asetaYhteydet(Lomake lomake, Asiakasrekisteri rekisteri,
													Tuotteet tuotteet, Valikkotoiminnot valikot){
		/**tll metodilla asetetaan viitteet niihin olioihin,joita luokassa
			 kytetn hyvksi. Ilman viitteit luokka ei toimi.*/
		this.lomake=lomake;
		this.rekisteri=rekisteri; 
		this.tuotteet=tuotteet;
		this.valikkotoiminnot=valikot;
	}
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
	public Panel annaJulkisivu(){
		/**metodi palauttaa valmiin paneelin, joka sislt kaikkien luokan
			 tarjoamien hakupalvelujen kyttmt graafiset kyttliitymkom-
			 ponentit valmiiksi aseteltuna paneelina*/
		return this.kokoJulkisivu;
	}

	//----------rekisterin avaus,tallennus ja uusi rekisteri-------------

  public boolean avaaRekisteri(String tiedostonimi){
		/**metodi avaa tallennetun rekisterin. Tiedosnime ei tarkisteta,
			 vaan metodi palauttaa arvon false, jos tiedosto ei ole 
			 kelvollinen */
		String[] uusiTuotelista;
		int listanPituus=this.tuotelista.getItemCount();
		//tyhjennetn kyttliittymn kaikki tuotelistat
		for(int i=0;i<listanPituus; i++){ 
			this.lomake.poistaTuote(this.tuotelista.getItem(i));
			this.tuotteet.poistaTuote(this.tuotelista.getItem(i));
 		}
		this.tuotelista.removeAll();
		try{
			FileInputStream tiedosto= new FileInputStream(tiedostonimi);
			ObjectInputStream tiedostosta=new ObjectInputStream(tiedosto);
			this.rekisteri=(Asiakasrekisteri)tiedostosta.readObject();
   	  uusiTuotelista=(String[])tiedostosta.readObject();
			tiedostosta.close();

		}catch(Exception e){
			this.uusiRekisteri();	
			this.asiakaslista.add("Virhe! Tiedosto ei kelvollinen.");
			return false;
			//avauksessa virhe, eli tiedosto ei sopiva
		}
		//annetaan kytettvn rekisterin viitteet muille kyttliittym-
		//luokille
		this.lomake.asetaRekisteri(this.rekisteri);
		this.valikkotoiminnot.asetaRekisteri(this.rekisteri);
		if(uusiTuotelista!=null){
			//listn avattavan rekisterin tuotelista kaikkiin tuotelistoihin
			listanPituus=uusiTuotelista.length;
			for(int i=0; i<listanPituus;i++){
				this.tuotelista.add(uusiTuotelista[i]);
				this.lomake.lisTuote(uusiTuotelista[i]);
				this.tuotteet.lisTuote(uusiTuotelista[i]);
			}		
		}
		this.haeKaikki();
		this.nappularyhm.setSelectedCheckbox(this.nytKaikki);
		return true;
  }
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  public boolean tallennaRekisteri(String tiedostonimi){
		/**metodi tallentaa nykyisen asiakasrekisterin tiedostonimen osoitta-
			 maksi tiedostoksi. Tiedoston olemassaoloa ei tarkisteta, vaan
			 kirjoitetaan automaattisesti plle. Onnistunut suoritus palauttaa
			 arvon true, eponnistunut false*/
		String[] nykylista=new String[this.tuotelista.getItemCount()];
		int listanPituus=this.tuotelista.getItemCount();

		for(int i=0; i<listanPituus; i++){				//kertn tuotelista
			nykylista[i]=this.tuotelista.getItem(i);
		}
		try{
			FileOutputStream tiedosto= new FileOutputStream(tiedostonimi);
			ObjectOutputStream tiedostoon=new ObjectOutputStream(tiedosto);

			tiedostoon.writeObject(this.rekisteri); //tallennetaan rekisteri
			tiedostoon.writeObject(nykylista);			//tallennetaan tuotelista
			tiedostoon.flush();
			tiedosto.close();
		}catch(Exception e){
			return false;
		}
		return true;
  }
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
	public void uusiRekisteri(){
		/**metodi avaa uuden tyhjn asiakasrekisterin*/
		int listanPituus=this.tuotelista.getItemCount();

		this.lomake.tyhjennLomake();
		this.rekisteri=new Asiakasrekisteri();
		//annetaan rekisteriviitteet muille kyttliittymluokille
		this.lomake.asetaRekisteri(this.rekisteri);
		this.valikkotoiminnot.asetaRekisteri(this.rekisteri);
		//poistetaan tuotteet kaikista tuotelistoista
		for(int i=0;i<listanPituus; i++){
			this.lomake.poistaTuote(this.tuotelista.getItem(i));
			this.tuotteet.poistaTuote(this.tuotelista.getItem(i));
		}
		this.tuotelista.removeAll();
		this.asiakaslista.removeAll();
		//<ei tuotetta> on pakko olla kaikissa tuotelistoissa
		this.tuotelista.add("<ei tuotetta>");
		this.lomake.lisTuote("<ei tuotetta>");
		this.tuotteet.lisTuote("<ei tuotetta>");
	}
	//----------asiakkaiden hallinta:lisys ja poisto rekisterist-------

  public void poistaAsiakas(){
		/**poistaa asiakkaan, joka on valittuna asiakaslistalla. Jos ei 
			 valittuja, ei poisteta ketn*/
		String poistettava=this.asiakaslista.getSelectedItem();
		if(poistettava!=null){
			this.rekisteri.poistaAsiakas(poistettava);
			this.asiakaslista.remove(poistettava);
			this.lomake.nytLomake();
		}
  }
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  public void poistaKaikki(){ 
		/**poistaa kaikki asiakaslistalla olevat asiakkaat*/
		int listanKoko=this.asiakaslista.getItemCount();
		if(listanKoko>0){
			for(int i=0; i<listanKoko;i++){ //tuhotaan asiakkaat yksitellen
				this.rekisteri.poistaAsiakas(this.asiakaslista.getItem(0));
			  this.asiakaslista.remove(0);
			}
		}
  	this.haeKaikki();
		this.nappularyhm.setSelectedCheckbox(this.nytKaikki);
  }

	//----------asiakkaiden haku rekisterist----------------------------
  public void haeKaikki(){
		/**hakee kaikkien rekisterin asiakkaiden nimet (suku,etu) nousevassa
			 aakkosjrjestyksess ja nytt ne asiakaslistalla*/
		String[] nytettv;	//aputaulukko
		this.asiakaslista.removeAll();
   		nytettv=this.rekisteri.haeKaikki(true);
		if(nytettv!=null && nytettv.length>0){
  		for(int i=0; i<nytettv.length;i++)
				this.asiakaslista.add(nytettv[i]);
			this.lomake.nytLomake();
		}
		else{
			this.asiakaslista.add("Asiakasrekisteri tyhj");
			this.lomake.tyhjennLomake();
		}			 
  }
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  private void haeTuotteella(){
		/**hakee kaikkien asiakkaiden nimet, joilla on se tuote, joka on 
			 valittuna hakupalvelun tuotelistassa*/
		String[] nytettv; //aputaulukko
		if(this.tuotelista.getSelectedItem()==null)
			return;
		this.asiakaslista.removeAll();
		this.asiakaslista.add("Haetaan....");
		nytettv=this.rekisteri.haeTuotteella(
																	  this.tuotelista.getSelectedItem());
		this.asiakaslista.removeAll();
		for(int i=0; i<nytettv.length;i++)
			this.asiakaslista.add(nytettv[i]);
		this.lomake.nytLomake();
		if(nytettv.length==0)
			this.asiakaslista.add("Ei lytyneit");
  }
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  private void haeHakusanalla(boolean nimi){
		/**hakee hakusanalla, joka on annettu hakusanakentss.
			 Jos parametri nimi=true, hakee ihmisten nimen perusteella,
			 muuten sarjanumeron*/
		String[] hakutulos;
		String aputulos;
		this.asiakaslista.removeAll();
		this.asiakaslista.add("Haetaan...");
		if(nimi)
			hakutulos=this.rekisteri.haeNimell(this.hakusana.getText());
		else{
			hakutulos=new String[1]; // muunnetaan String String-taulukoksi
			aputulos=this.rekisteri.haeSarjanumerolla(
																							this.hakusana.getText());
			if(aputulos!=null)
				hakutulos[0]=aputulos;
			else
				hakutulos=null;
		}	
		this.asiakaslista.removeAll();
		if(hakutulos!=null){
			for(int i=0; i<hakutulos.length; i++)
				this.asiakaslista.add(hakutulos[i]);	//nytetn tulokset
			if(hakutulos.length==0)
				this.asiakaslista.add("Ei lytyneit");
			else
				this.lomake.nytLomake();			
		}
		else
  		this.asiakaslista.add("Ei lytyneit");	
  }
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  private void haeAjalla(boolean syntymaika){
		/**metodi hakee asiakasrekisterist joko syntym- tai rekisteri-
			 tymispivll ja lis lydettyjen asiakkaiden nimet (suku,etu)
			 asiakaslistaan.*/
		String[] hakutulos;
		String syte;
		this.asiakaslista.removeAll();
		//tarkistetaan aikasytteiden oikeellisuus, niiden on oltava oikein
		if(Virheentarkistus.pivyskentt(this.hakupiv,true) &&
			 Virheentarkistus.pivyskentt(this.hakukuu,false) &&
			 Virheentarkistus.vuosikentt(this.hakuvuosi)){
				this.asiakaslista.add("Haetaan...");
				//muunnetaan syte asiakasrekisterille sopivaksi merkkijonoksi
				//kyttmll Lomake-luokan palvelua
				syte=this.lomake.muotoilePivys(this.hakupiv.getText(),
																					this.hakukuu.getText(),
																					this.hakuvuosi.getText());
				if(syntymaika)
					hakutulos=this.rekisteri.haeSyntymajalla(syte);
				else
					//haetaan rekisteritymispivll
					hakutulos=this.rekisteri.haeRekisteritymispivll(syte);
				this.asiakaslista.removeAll();
				if(hakutulos!=null){
					for(int i=0; i<hakutulos.length; i++)
						this.asiakaslista.add(hakutulos[i]);
					if(hakutulos.length==0)
						this.asiakaslista.add("Ei lytyneit");
					this.lomake.nytLomake();
				}
				else
					this.asiakaslista.add("Ei lytyneit");
		}
		else
			//hakuehdossa ollut virhe
			this.asiakaslista.add("Tarkista antamasi pivys");
  }
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  private void haeNimell(){
		/**metodi hakee nimell asiakasrekisterist ne asiakkaat, joiden
			 nimen alusta lytyy hakusanakenttn annettu merkkijono*/
		this.haeHakusanalla(true);
  }
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  private void haeSarjanumerolla(){
		/**metodi hakee sen asiakkaan, jonka sarjanumero on hakusanakentss
			 annettu. Lydettyj voi olla korkeintaan yksi.*/
		this.haeHakusanalla(false);
  }
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  private void haeRekisteritymisajalla(){
		/**metodi hakee niiden asiakkaiden nimet, jotka ovat rekisterityneet
			 aika -kentiss annettuna aikana. Sytteiden oikeellisuus 
			 tarkastetaan.*/
		this.haeAjalla(false);
  }
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  private void haeSyntymajalla(){
		/**metodi hakee niiden asiakkaiden nimet, jotka ovat syntyneet
			 aika -kentiss annettuna aikana. Sytteiden oikeellisuus 
			 tarkastetaan.*/
		this.haeAjalla(true);
  }
	//----------tuotteiden lisminen ja poistaminen---------------------
	public void lisTuote(String listtv){
		/**tm metodi lis uuden annetun tuotteen nimen hakupalvelun 
			 tuotelistaan*/
		this.tuotelista.add(listtv);
	}
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
	public void poistaTuote(String poistettava){
		/**metodi poistaa annetun nimisen tuotteen rekisterist,
			 samalla poistuvat mahdolliset tuotteiden omistajat
			 ja asiakaslista nytt kaikki asiakkaat.*/
		this.tuotelista.remove(poistettava); 
		this.asiakaslista.removeAll();
		this.asiakaslista.add("Poistetaan tuotteen omistajia...");
		this.rekisteri.poistaTuote(poistettava, true);
		this.asiakaslista.removeAll();
		this.haeKaikki();
		this.nappularyhm.setSelectedCheckbox(this.nytKaikki);
	}

	//----------tapahtuman ohjaus ja nkymn pivitys-------------------
	public void pivit(){
		/**metodi pivitt hakupalvelun graafisen nkymn*/
		if(this.nappularyhm.getSelectedCheckbox()==this.nytKaikki)
			this.haeKaikki();
		else if(this.nappularyhm.getSelectedCheckbox()==this.nytTuotteella)
			this.haeTuotteella();
		else if(this.nappularyhm.getSelectedCheckbox()==this.nytHaulla){
			if(this.hakuperuste.getSelectedItem().indexOf("nimi")>0)
				this.haeNimell();
			else if(this.hakuperuste.getSelectedItem().indexOf("syntymaika")>0)
				this.haeSyntymajalla();
			else if(this.hakuperuste.getSelectedItem().indexOf("sarjanumero")>0)
				this.haeSarjanumerolla();
			else if(this.hakuperuste.getSelectedItem().indexOf(
																								"rekisteritymispiv")>0)
				this.haeRekisteritymisajalla();
		}
	}
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  public void actionPerformed(ActionEvent tapahtuma){
		/**tapahtuman ohjaus: jakaa tapahtumat tmn luokan oikeille apume-
			 todeille.*/
		Object aiheuttaja=tapahtuma.getSource();

		if(aiheuttaja==this.asiakaslista){ //nytetn listalta valittu asiakas
			this.rekisteri.haeNimell(this.asiakaslista.getSelectedItem());
			this.lomake.nytLomake();
		}			
		if(aiheuttaja==this.nyt){
			if(this.nappularyhm.getSelectedCheckbox()==this.nytKaikki)
				this.haeKaikki();
			else if(this.nappularyhm.getSelectedCheckbox()
																									==this.nytTuotteella)
				this.haeTuotteella();
			else if(this.nappularyhm.getSelectedCheckbox()==this.nytHaulla){
				if(this.hakuperuste.getSelectedItem().indexOf("nimi")>=0)
					this.haeNimell();
				else if(this.hakuperuste.getSelectedItem().indexOf(
																											 "syntymaika")>=0)
					this.haeSyntymajalla();
				else if(this.hakuperuste.getSelectedItem().indexOf(
																											 "sarjanumero")>=0)
					this.haeSarjanumerolla();
				else if(this.hakuperuste.getSelectedItem().indexOf(
																							"rekisteritymispiv")>=0)
					this.haeRekisteritymisajalla();
			}
		}
		else if(aiheuttaja==this.poistaAsiakkaat){
			this.poistaAsiakas();	
		}
		else if(aiheuttaja==this.poistaKaikki){
			this.poistaKaikki();	
		}
  }
}

