import java.awt.*;
import java.awt.event.*;
/*====================================================================
* Luokka asiakastietolomakkeen tuotteiden valintaa varten. Luokka 
*	tarvitsee yhteydet luokkiin: Lomake,Tietokantapalvelut,
*	Asiakasrekisteri, Valikkotoiminnot
*
* 
* Kirjoittanut: Ahti Syreeni
* Pvm: 11.2.2000
=====================================================================*/
public class Tuotteet implements ActionListener{
	//------------------------tarvittavat luokat------------------------
	private Lomake lomake;
	private Tietokantapalvelut tietokantapalvelut;
	private Asiakasrekisteri asiakasrekisteri;
	//-------------------kyttliittymelementit------------------------
	private Panel tuotepaneeli, nappulapalkki;
	private List tuotelista; 
	private TextField tuotelisys; //kentt listtvn tuotteen antamiselle
	private Button lisTuote, poistaTuote;
	//---------------------konstruktori---------------------------------
	public Tuotteet(){
		this.tuotelisys=new TextField(20);
		this.tuotepaneeli= new Panel(new GridLayout(1,2));
		this.nappulapalkki= new Panel(new GridLayout(5,1));

		this.lisTuote= new Button("Lis tuote");
		this.lisTuote.addActionListener(this);
		this.poistaTuote=new Button("Poista tuote");
		this.poistaTuote.addActionListener(this);
		this.tuotelista=new List();
		this.tuotelista.addActionListener(this);

		this.tuotepaneeli.add(this.tuotelista);
		
		this.nappulapalkki.add(this.lisTuote);
		this.nappulapalkki.add(new Label(""));
		this.nappulapalkki.add(this.poistaTuote);
		this.nappulapalkki.add(new Label("Listtv tuote:"));
		this.nappulapalkki.add(this.tuotelisys);
		this.tuotepaneeli.add(this.nappulapalkki);
	}
	//-------------------------julkisivun vlitys------------------------
	public Panel annaJulkisivu(){
		/**palauttaa kyttliittymn tuotteenhallinta-osan kyttliittym-
			elementit valmiiksi muotoiltuna paneelina*/
		return this.tuotepaneeli;
	}
	//------------------yhteyden asetttaminen----------------------------
  public void asetaYhteydet(Tietokantapalvelut palvelu, 
														Asiakasrekisteri rekisteri, Lomake lomake, 
														Valikkotoiminnot valikkotoiminnot){
		/**tll metodilla asetetaan yhteydet tietokantapalveluihin,asiakas-
			 rekisteriin,lomakkeeseen ja valikkotoimintoihin*/
		this.lomake=lomake;
		this.asiakasrekisteri=rekisteri;
		this.tietokantapalvelut=palvelu;  
		//on mys listtv oletustuote kaikkiin kyttliittymn elementtei-
		//hin, koska tm voidaan tehd vasta yhteyden asettamisen jlkeen
		this.tuotelista.add("<ei tuotetta>");
		this.lomake.lisTuote("<ei tuotetta>");
		this.tietokantapalvelut.lisTuote("<ei tuotetta>");
  }
	//------------------tuotteiden lisys ja poisto----------------------
  public void lisTuote(){
		/**lis tekstikentss "listtv tuote annetun tuotteen kaikkiin 
			 kyttliittymn tuotelistoihin*/
		String listtv=this.tuotelisys.getText();
		if(listtv==null || listtv.equals(""))
			return; //ei voi olla tyhj tuotenime listalla
		for(int i=0;i<this.tuotelista.getItemCount();i++){
			if(listtv.equals(this.tuotelista.getItem(i))){
				this.tuotelisys.selectAll(); //onko tuote jo listalla?
				return;
			}
		}
		this.tuotelista.add(listtv);
		this.lomake.lisTuote(listtv); //listtv mys kyttliit-
																			 //tymn muiden osien listoihin
 		this.tietokantapalvelut.lisTuote(listtv);
		this.tuotelisys.setText("");
  }
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  public void poistaTuote(){
		/**poistaa tuotelistalta valitun tuotteen kyttliittymn kaikilta
			 tuotelistoilta ja poistaa tuotteen kaikki asiakkaat asiakasrekis-
			 terist*/
		String poistettava=this.tuotelista.getSelectedItem();
		if(poistettava==null || poistettava.equals("<ei tuotetta>")){
			return; //<ei tuotetta> oltava aina olemassa
		}
		this.asiakasrekisteri.poistaTuote(poistettava,true);
		this.tietokantapalvelut.poistaTuote(poistettava);
		this.lomake.poistaTuote(poistettava);
		this.tuotelista.remove(poistettava);
  }
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  public void lisTuote(String tuote){
		/**lis annetun tuotteen tuote-osion tuotelistalle*/
		this.tuotelista.add(tuote);
	}
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  public void poistaTuote(String tuote){
		/**poistaa annetun tuotteen tuotelistalta*/
		this.tuotelista.remove(tuote);
	}
	//-----------------------tapahtuman ohjaus---------------------------
  public void actionPerformed(ActionEvent tapahtuma){
		Object aiheuttaja=tapahtuma.getSource();
		if(aiheuttaja==this.lisTuote)
			this.lisTuote();
		else if(aiheuttaja==this.poistaTuote)
			this.poistaTuote();
		else if(aiheuttaja==this.tuotelisys)
			this.lisTuote();
  }
}
