import java.awt.*;
import java.awt.event.*;

/*=====================================================================
* Aino-asiakasrekisterin valikkotoiminnot.
* 
* Kirjoittanut: Ahti Syreeni
* Pvm: 15.2.2000
======================================================================*/  

public class Valikkotoiminnot extends Frame implements ActionListener{
	//-------------------------kytettvt luokat------------------------
	private Lomake							lomakeolio;
	private Tietokantapalvelut 	tietokantaolio;
	private Tuotteet						tuoteolio;
	private boolean 						tallennettu;
	private String 							tallennusTiedosto,rekisteriNimi;
	private	Asiakasrekisteri		rekisteri;
	//---------------------kyttliittymelementit-----------------------
	private FileDialog	tallennusikkuna,avausikkuna,htmlTallennusikkuna;
	private MenuBar 		valikko;
	private MenuItem 		avaa,uusi,tallenna,vlitallenna,tallennaHtml,lopeta,
									 		uusiLomake,poistaLomake,poistaKaikki,edellinenLomake,
									 		seuraavaLomake,lisTuote,poistaTuote;
	private Menu		 		tiedosto,lomake,tuotteet;
  //-----------------------konstruktori--------------------------------
	public Valikkotoiminnot(){
		this.valikko=new MenuBar(); 
		//valikot
		this.tiedosto=new Menu("Tiedosto");
		this.lomake=new Menu("Lomake");
		this.tuotteet=new Menu("Tuotteet");
		//tiedosto-valikko
		this.avaa=new MenuItem("Avaa");
		this.avaa.addActionListener(this);
		this.uusi=new MenuItem("Uusi");
		this.uusi.addActionListener(this);
		this.tallenna=new MenuItem("Tallenna nimell");
		this.tallenna.addActionListener(this);
		this.vlitallenna=new MenuItem("Tallenna");
		this.vlitallenna.addActionListener(this);
		this.tallennaHtml=new MenuItem("Tallenna Html-tiedostoksi");
		this.tallennaHtml.addActionListener(this);
		this.lopeta=new MenuItem("Lopeta");
		this.lopeta.addActionListener(this);		
		//lomake-valikko
		this.uusiLomake=new MenuItem("Uusi lomake");
		this.uusiLomake.addActionListener(this);
		this.poistaLomake=new MenuItem("Poista valittu asiakas");
		this.poistaLomake.addActionListener(this);
		this.poistaKaikki=new MenuItem("Poista listan asiakkaat");
		this.poistaKaikki.addActionListener(this);
		this.edellinenLomake=new MenuItem("Edellinen lomake");
		this.edellinenLomake.addActionListener(this);
		this.seuraavaLomake=new MenuItem("Seuraava lomake");
		this.seuraavaLomake.addActionListener(this);
		//tuote-valikko
		this.lisTuote=new MenuItem("Lis tuote");
		this.lisTuote.addActionListener(this);
		this.poistaTuote=new MenuItem("Poista valittu tuote");
		this.poistaTuote.addActionListener(this);
		
		valikko.add(this.tiedosto);
		valikko.add(this.lomake);
		valikko.add(this.tuotteet);
		//listn luodut oliot valikkoihin
		this.tiedosto.add(this.avaa);
		this.tiedosto.add(this.uusi);
		this.tiedosto.add(new MenuItem("-"));
		this.tiedosto.add(this.vlitallenna);
		this.tiedosto.add(this.tallenna);
		this.tiedosto.add(this.tallennaHtml);
		this.tiedosto.add(new MenuItem("-"));
		this.tiedosto.add(this.lopeta);

		this.lomake.add(this.uusiLomake);
		this.lomake.add(this.edellinenLomake);
		this.lomake.add(this.seuraavaLomake);
		this.lomake.add(new MenuItem("-"));
		this.lomake.add(this.poistaLomake);
		this.lomake.add(this.poistaKaikki);
		
		this.tuotteet.add(this.lisTuote);
		this.tuotteet.add(this.poistaTuote);
		//tallennuselementit
		this.htmlTallennusikkuna=new FileDialog(
																		this,"Tallenna Html-tiedostoksi",1);
		this.tallennusikkuna=new FileDialog(this,"Tallenna nimell",1);
		this.avausikkuna=new FileDialog(this,"Avaa asiakasrekisteri");
		this.rekisteriNimi=" ";
		this.tallennettu=true;
	}
	//---------------------tallennusmetodit------------------------------
  private void tallennaAsiakasrekisteri(){
		/**tallentaa asiakasrekisterin tiedostonvalintaikkunassa valitulle 
		 	 nimelle. Tiedostopte on .rek.*/
		String tiedostonimi,apu;
		this.lomakeolio.vieRekisteriin(); //mys nykyinen lomake mukaan
		this.tallennusikkuna.show();
		if(this.tallennusikkuna.getFile()==null)
			return;
		apu=this.tallennusikkuna.getDirectory()+this.tallennusikkuna.getFile();
		if(apu.indexOf(".")>-1)
			apu=apu.substring(0,apu.indexOf(".")); //eliminoidaan mahdolliset
																						 //annetut ptteet
		tiedostonimi=apu.concat(".rek"); 			//listn Ainon oma pte
		if(this.tietokantaolio.tallennaRekisteri(tiedostonimi)){
			this.tallennusTiedosto=tiedostonimi;
			this.rekisteriNimi=this.tallennusikkuna.getFile();
			this.tallennettu=true;
			//tiedoston tallennus onnistui
		}
  }
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  private void vlitallennaAsiakasrekisteri(){		
		/**tallentaa asiakasrekisterin aikaisemmin tallennetulle tiedostoni-
			 melle. Jos ei ole mritelty, avaa tallennusikkunan*/
		if(this.tallennusTiedosto!=null){
			this.lomakeolio.vieRekisteriin(); //nykyinen lomake mukaan
			this.tietokantaolio.tallennaRekisteri(this.tallennusTiedosto);
		}
		else{
			this.tallennaAsiakasrekisteri();
		}
		this.tallennettu=true;
  }
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  private void kirjoitaHtmltiedosto(){
		/**kirjoittaa Html-tiedoston rekisterin asiakkaista*/
		String tiedostonimi,osoite;
		Html	 kirjoitin;

		this.lomakeolio.vieRekisteriin();
		if(this.rekisteri.rekisteriKoko()<1)
			return;
		this.htmlTallennusikkuna.show();
		if(this.htmlTallennusikkuna.getFile()==null)
			return; //ei valittua, tai painettu Cancel
		tiedostonimi=this.htmlTallennusikkuna.getDirectory()
																			+this.htmlTallennusikkuna.getFile();
		kirjoitin=new Html();
		if(kirjoitin.alustaTiedosto(tiedostonimi,this.rekisteriNimi,true)){
			kirjoitin.otsikko(("Rekisterin "+this.rekisteriNimi+" asiakkaat"),1);
			//asetetaan asiakasrekisteri alkuun
			this.rekisteri.selaa(this.rekisteri.rekisteriKoko(),false); 
			for(int i=0;i<this.rekisteri.rekisteriKoko();i++){ 
				kirjoitin.otsikko(this.rekisteri.annaSukunimi()+", "
													+this.rekisteri.annaEtunimi(),3);
				kirjoitin.lista(false); 				
				kirjoitin.listaAlkio("Nimi- ja syntymtiedot");
				kirjoitin.lista(false); 				
    		kirjoitin.listaAlkio(("Etunimi: "+this.rekisteri.annaEtunimi()));
				kirjoitin.listaAlkio(("Sukunimi: "+this.rekisteri.annaSukunimi()));
				kirjoitin.listaAlkio(("Syntymaika: "
															+this.rekisteri.annaSyntymaika()));										 
				kirjoitin.sulje();
				kirjoitin.listaAlkio("Osoitetiedot");
				kirjoitin.lista(false); 				
    		kirjoitin.listaAlkio(("Katuosoite: "
															+this.rekisteri.annaKatuosoite()));
				kirjoitin.listaAlkio(("Postinumero: "
															+this.rekisteri.annaPostinumero()));
				kirjoitin.listaAlkio(("Kaupunki: "
															+this.rekisteri.annaKaupunki()));										 
    		kirjoitin.listaAlkio(("Maa: "
															+this.rekisteri.annaMaa()));
				kirjoitin.listaAlkio(("Puhelin: "	
															+this.rekisteri.annaPuhelinnumero()));
				kirjoitin.listaAlkio(("Shkposti: "+kirjoitin.shkposti(" ",
														this.rekisteri.annaShkpostiosoite(),true)));										 
				kirjoitin.sulje();
				kirjoitin.listaAlkio("Tuotetiedot: ");
				kirjoitin.lista(false); 				
    		kirjoitin.listaAlkio(("Tuote: "+this.rekisteri.annaTuote()));
				kirjoitin.listaAlkio(("Sarjanumero: "
																		+this.rekisteri.annaSarjanumero()));
				kirjoitin.listaAlkio(("Rekisterimispiv: "+
															 this.rekisteri.annaRekisteritymispiv()));										 
				kirjoitin.sulje();
				kirjoitin.sulje();
				this.rekisteri.selaa(1,true);
			}
			kirjoitin.otsikko("Yhteens:"+this.rekisteri.rekisteriKoko()
												 +" asiakasta",8);
			kirjoitin.sulje();
			kirjoitin.sulje();
		}
  }
	//--------------------------rekisterin avaus-------------------------
	private void avaaAsiakasrekisteri(){
		/**avaa tallennetunrekisterin, joka valitaan 
			 tiedostonavausikkunasta. Jos ei onnistu, avaa uuden tyhjn
			 rekisterin*/
		String tiedostonimi;
		if(!this.tallennettu)
			this.tallennaAsiakasrekisteri();
		this.avausikkuna.show();
		if(this.avausikkuna.getFile()==null)
			return; //ei valittua, tai painettu Cancel
		tiedostonimi=this.avausikkuna.getDirectory()+this.avausikkuna.getFile();
		if(this.tietokantaolio.avaaRekisteri(tiedostonimi)){
			this.tietokantaolio.haeKaikki();	
			this.rekisteriNimi=this.avausikkuna.getFile();
			this.tallennusTiedosto=tiedostonimi;
			this.tallennettu=true;
		}
	}
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
	private void uusiAsiakasrekisteri(){
		/**avaa uuden tyhjn asiakasrekisterin*/
		this.lomakeolio.vieRekisteriin();
		if(!this.tallennettu)
			this.tallennaAsiakasrekisteri();
		this.tietokantaolio.uusiRekisteri();	
		this.tallennettu=true;
	}
	//-------------------------yleiset-----------------------------------
  public void lopetus(){
	 /**lopettaa ohjelman kytn*/
	 if(!this.tallennettu)
			this.tallennaAsiakasrekisteri();
	 System.exit(0);
  }
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
	public void asetaRekisteri(Asiakasrekisteri rekisteri){
		/**tll metodilla asetetaan kytettv asiakasrekisteri*/
		this.rekisteri=rekisteri;
	}
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
	public MenuBar annaValikko(){
		/**palauttaa valmiin valikkorakenteen MenuBar-tietotyyppin*/
		return this.valikko;
	}
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
	public void tehtyMuutoksia(){
		/**tll metodilla ohjelman eri osat voivat ilmoittaa, ett on 
			 tapahtunut muutoksia, ja tallentamista on syyt ehdottaa 
			 lopetuksen ja avaamisen yhteydess*/
		this.tallennettu=false;
	}
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  public void asetaYhteydet(Lomake lomake, Tietokantapalvelut palvelu, 
														Tuotteet tuotteet){
		/**metodi yhteyksien asettamiseen kyttliittymn eri 
			 kokonaisuuksiin*/
		this.lomakeolio=lomake;
		this.tietokantaolio=palvelu;
		this.tuoteolio=tuotteet;
  }
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  public void actionPerformed(ActionEvent tapahtuma){
		/**tapahtuman ohjaus. Jakaa tehtvt luokan metodeille*/
		Object aiheuttaja=tapahtuma.getSource();
		if(aiheuttaja==this.avaa)
			this.avaaAsiakasrekisteri();
		else if(aiheuttaja==this.uusi)
			this.uusiAsiakasrekisteri();
		else if(aiheuttaja==this.vlitallenna)
			this.vlitallennaAsiakasrekisteri();
		else if(aiheuttaja==this.tallenna)			
			this.tallennaAsiakasrekisteri();
		else if(aiheuttaja==this.tallennaHtml)
			this.kirjoitaHtmltiedosto();
		else if(aiheuttaja==this.lopeta)
			this.lopetus();
		else if(aiheuttaja==this.uusiLomake)
			this.lomakeolio.uusiLomake();
		else if(aiheuttaja==this.edellinenLomake)
			this.lomakeolio.edellinenLomake();
		else if(aiheuttaja==this.seuraavaLomake)
			this.lomakeolio.seuraavaLomake();
		else if(aiheuttaja==this.poistaLomake)
			this.tietokantaolio.poistaAsiakas();
		else if(aiheuttaja==this.poistaKaikki)
			this.tietokantaolio.poistaKaikki();
		else if(aiheuttaja==this.lisTuote)
			this.tuoteolio.lisTuote();
		else if(aiheuttaja==this.poistaTuote)
			this.tuoteolio.poistaTuote();
  }
}
