import java.awt.*;
/*=====================================================================
*Kirjastoluokka yleisi virheentarkistuksia varten. Sislt virheen-
*tarkistukset merkkijonotyyppiselle pivykselle,pivystekstikentlle  
*sek tekstikentlle, joka on tarkoitettu vuosiluvun syttmiseen
*
*Kirjoittanut: Ahti Syreeni
*Pvm: 2.2.2000
=====================================================================*/

public final class Virheentarkistus{
	private static final int alinVuosi=1900; //alin sallittu vuosi
																					 //vuositekstikentlle
	private Virheentarkistus(){}
	public static boolean pivys(String pivys,int pieninSallittuVuosi){
		/** Tarkistaa annetun pivyksen. Pivys on oltava muotoa: 
				kaksinumeroinen piv ja kuukausinumero ja nelinumeroinen 
				vuosiluku,joissa piv 1-31 ja kuukausi 1-12. Toinen parametri 
				mritt alimman hyvksytyn vuosiluvun.  Esim.31051999 = 
				31.5.1999 */ 
		if(pivys==null)
			return false;
	  if(pivys.length()!=8) return false; //merkkijonon pituus oltava 8
		try{
			int piv;
			piv=java.lang.Integer.parseInt(""+pivys.charAt(0)+
																										 pivys.charAt(1));
			if(piv>31 || piv<1) return false; 

			int kuukausi;
			kuukausi=java.lang.Integer.parseInt(""+pivys.charAt(2)+
																										pivys.charAt(3));
			if(kuukausi>12 || kuukausi<0) return false;

			int vuosi; 
			String apu="";
			for(int i=4; i<8;i++)
			apu+=pivys.charAt(i);
			vuosi=java.lang.Integer.parseInt(apu);
		  if(vuosi<pieninSallittuVuosi) return false;

		}catch(Exception e){
			return false; //jos annetussa merkkijonossa ollut kirjaimia 
									  //tms. parseInt() aiheuttaa poikkeuksen eli syte
										//on ollut kelvoton
		}
	  return true;	
  }
	public static boolean shkpostiosoite(String osoite){
		/** metodi tarkistaa, onko annetussa merkkijonossa merkki '@'
				Jos ei, annettu merkkijono ei voi olla shkpostiosoite*/
		if(osoite==null)
			return false;
		if(osoite.indexOf('@')>0) 
			return true;
		else 
			return false;
	}

	public static boolean pivyskentt(Object pivyskentt, boolean piv){
		/**metodi tarkistaa, onko sytteen annetussa tekstikentss oleva 
			merkkijono piv tai kuukausi: pivn vlill 1-31,kuukausi 1-12.
			Se, kumpana metodi kentn ksittelee, rippuu parametrista piv.
			Jos kentn arvo virheellinen, valitaan koko tekstikentt, muuten
			poistetaan mahdollinen valinta*/ 
		TextField pivystekstikentt=(TextField)pivyskentt;
		String pivys=pivystekstikentt.getText();
		int pivysnumero=0;
		boolean ok=true;

		if(pivys.length()>2) //pivys enintn 2 numeroa pitk
			ok=false;
		try{
			pivysnumero=Integer.parseInt(pivys); 
		}catch(Exception e){ //pivys ei saa sislt kuin numeroita
			ok=false;
		}
		if(piv){
			if(pivysnumero<1 ||pivysnumero>31) 
				ok=false;
		}
		else{
			if(pivysnumero<1 || pivysnumero>12)
				ok=false;
		}

		if(!ok){
			pivystekstikentt.selectAll(); //valitaan koko kentt virheen 
																			 //ilmaisemiseksi
		}
		else{
			pivystekstikentt.select(0,0);
		}
		if(ok)
			return true;
		else
			return false;
	}
	public static boolean vuosikentt(Object vuosikentt){
		/**metodi tarkistaa, onko sytteen annetussa tekstikentss oleva 
			merkkijono vuosi. Sen on oltava yli luokan vakion "alinVuosi" ja
			nelinumeroinen numero.Jos kentn arvo virheellinen, valitaan 
			koko tekstikentt, muuten poistetaan mahdollinen valinta*/ 
		TextField vuositekstikentt=(TextField)vuosikentt;
		String vuosi=vuositekstikentt.getText();
		int vuosinumero=0;
		boolean ok=true;

		if(vuosi.length()>4)
			ok=false;
		try{
			vuosinumero=Integer.parseInt(vuosi);
		}catch(Exception e){
			ok=false;		//tarkistetaan, ett arvossa vain numeroita
		}
		if(vuosinumero<alinVuosi)  //arvon oltava yli luokkavakio"alinVuosi"
				ok=false;

		if(!ok)
			vuositekstikentt.selectAll();
		else
			vuositekstikentt.select(0,0);
		if(ok)
			return true;
		else
			return false;

	}
}